# neutron_lib.services.qos.base module

class neutron_lib.services.qos.base.DriverBase(*args, **kwargs)

  Bases: `object`

  create_policy(context, policy)

    Create policy invocation.

    This method can be implemented by the specific driver subclass to update the backend where necessary with the specific policy information.

    Parameters:

      - context – current running context information

      - policy – a QoSPolicy object being created, which will have no rules.

  create_policy_precommit(context, policy)

    Create policy precommit.

    This method can be implemented by the specific driver subclass to handle the precommit event of a policy that is being created.

    Parameters:

      - context – current running context information

      - policy – a QoSPolicy object being created, which will have no rules.

  delete_policy(context, policy)

    Delete policy invocation.

    This method can be implemented by the specific driver subclass to delete the backend policy where necessary.

    Parameters:

      - context – current running context information

      - policy – a QoSPolicy object being deleted

  delete_policy_precommit(context, policy)

    Delete policy precommit.

    This method can be implemented by the specific driver subclass to handle delete precommit event of a policy that is being deleted.

    Parameters:

      - context – current running context information

      - policy – a QoSPolicy object being deleted

  is_loaded()

    True if the driver is active for the Neutron Server.

    Implement this property to determine if your driver is actively configured for this Neutron Server deployment.

  is_rule_supported(rule)
  is_vif_type_compatible(vif_type)

    True if the driver is compatible with the VIF type.

  is_vnic_compatible(vnic_type)

    True if the driver is compatible with the specific VNIC type.

  update_policy(context, policy)

    Update policy invocation.

    This method can be implemented by the specific driver subclass to update the backend where necessary.

    Parameters:

      - context – current running context information

      - policy – a QoSPolicy object being updated.

  update_policy_precommit(context, policy)

    Update policy precommit.

    This method can be implemented by the specific driver subclass to handle update precommit event of a policy that is being updated.

    Parameters:

      - context – current running context information

      - policy – a QoSPolicy object being updated.

  validate_rule_for_network(context, rule, network_id)

    Return True/False for valid/invalid.

    This is only meant to be used when a rule is compatible with some networks but not with others (depending on network properties).

    Returns True by default for backwards compatibility.

  validate_rule_for_port(context, rule, port)

    Return True/False for valid/invalid.

    This is only meant to be used when a rule is compatible with some ports/networks but not with others (depending on port/network properties).

    Returns True by default for backwards compatibility.

this page last updated: 2026-08-15 12:38:23

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug